#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "board_resource.h"

#define LED_NUMS (7)

static void print_usage()
{
	printf("Usage:\n");
	printf("\t ledtest  #auto run led\n");
	printf("\t ledtest led_number on/off \n");
	printf("\t ledtest 0 on \n");
	printf("\t 0 = LED RUN  \n");
	printf("\t 1 = LED ERROR  \n");
	printf("\t 2 = LED Program \n");
	printf("\t 3 = LED 1  \n");
	printf("\t 4 = LED 2  \n");
	printf("\t 5 = LED 3 \n");
	printf("\t 6 = LED 4 \n");
}
char *led_name[LED_NUMS]=
{
	   "LED RUN",
	   "LED ERROR",
	   "LED PROGRAM",
	   "LED 1",
	   "LED 2",
	   "LED 3",
	   "LED 4"
};

int led_fd[LED_NUMS] = { -1 };


static void change_led(int led_type,int status)
{
	int fd =0;
	BR_RESULT ret = BR_SUCCESS;

	if(led_type >= LED_NUMS)
	{
		printf("LED not exist\n");
		return ;
	}

	ret = LED_Init(led_type, &fd);
	if (ret != BR_SUCCESS)
		printf("[%s]open fail[%d]\n", led_name[led_type],ret);

	if(status)
	{
		printf("led [%s] on\n", led_name[led_type]);
		LED_On(fd);
		usleep(100*1000);
	}else
	{
		printf("led [%s] off\n", led_name[led_type]);
		LED_Off(fd);
		usleep(100*1000);
	}
//	LED_DeInit(fd);
	return ;
}

int main(int argc, char *argv[])
{
	int index_led = 0;
	if(argc > 1)
	{
		if(argc != 3)
		{
			print_usage();
			return -1;
		}

		if(strcmp(argv[2],"on")&&strcmp(argv[2],"off"))
		{
			print_usage();
			return -1;
		}

		if(!strcmp(argv[2],"on"))
		{
			change_led(atoi(argv[1]),1);
		}else if(!strcmp(argv[2],"off"))
		{
			change_led(atoi(argv[1]),0);
		}else
		{
			print_usage();
			return -1;
		}
		return 0;
	}

	BR_RESULT ret = BR_SUCCESS;
	int count = 0;
	for(index_led =0 ; index_led < LED_NUMS ;index_led++ )
	{
		ret = LED_Init(index_led, &led_fd[index_led]);
		if (ret != BR_SUCCESS)
			printf("open led [%s] fail[%d]\n", led_name[index_led],ret);
		else
		{
			printf("open led [%s] success\n", led_name[index_led]);
			count++;
		}
	}

	while (count)
	{
		for(index_led =0 ; index_led < LED_NUMS ;index_led++ )
		{
			if(led_fd[index_led] <= 0)
				continue;
			printf("led [%s] on\n", led_name[index_led]);
			LED_On(led_fd[index_led]);
			sleep(1);
		}
		for(index_led =0 ; index_led < LED_NUMS ;index_led++ )
		{
			if(led_fd[index_led] <= 0)
				continue;
			printf("led [%s] off\n", led_name[index_led]);
			LED_Off(led_fd[index_led]);
			sleep(1);
		}
	}

	return 0;
}
